;by qWord - 2008-2009
; thanks go to: drizz and raymond
;
.nolist
include masm32rt.inc
include MagicNumber64.Inc
.686p
.mmx
.xmm

.const
	szClassName			db 'DLGCLASS',0
	szAppName			db 'Unsigned division by constant',0
	szNullString		db 0
	szRichEditDLL 		db "RichEd20.dll",0
	szNewLine			db 10,0
	szSemicolon			db 03bh,0
	nl					EQU <OFFSET szNewLine>
	sc					EQU <OFFSET szSemicolon>
.data
	g_bNoText			dd 1
.data?
	wc 					WNDCLASSEX	<>
	msg					MSG			<>
	
	align 4
	g_hInstance			dd ?
	g_hMainDlg			dd ?
	g_hRichEditDLL		dd ?
	g_hRichEdit			dd ?
	g_hEdit 			dd ?
	g_hBtnIs64 			dd ?
	g_hBtnIs32 			dd ?
	g_hBtnIs16			dd ?
	g_hChkSign			dd ?
	g_pfnEdit			dd ?
	
	d64					div_64	<>
	d32					div_32	<>
	d16					div_16	<>
	sd64				div_s64 <>
	sd32				div_s32	<>
	sd16				div_s16 <>
.code

start:
	invoke InitCommonControls
	mov g_hRichEditDLL,rv(LoadLibrary,OFFSET szRichEditDLL)
	mov g_hInstance,rv(GetModuleHandle,0)
	mov wc.hInstance,eax
	mov wc.cbSize,SIZEOF WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,OFFSET WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,DLGWINDOWEXTRA
	mov	wc.hbrBackground,COLOR_WINDOW+1
	mov	wc.lpszMenuName,0
	mov	wc.lpszClassName,OFFSET szClassName
	mov	wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov	wc.hIconSm,eax
	mov	wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx,OFFSET wc
	
	invoke CreateDialogParam,g_hInstance,IDD_DIALOG,0,OFFSET WndProc,0
	invoke ShowWindow,eax,SW_SHOWNORMAL
	invoke UpdateWindow,g_hMainDlg
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam

	invoke FreeLibrary,g_hRichEditDLL
	invoke ExitProcess,0


align 16
WndProc proc hWnd:DWORD,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
;LOCAL hGlbMem:DWORD

	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		m2m	g_hMainDlg,hWnd
		mov g_hRichEdit,rv(GetDlgItem,hWnd,IDC_RICH)
		mov g_hEdit,	rv(GetDlgItem,hWnd,IDC_EDIT)
		mov g_hBtnIs64,	rv(GetDlgItem,hWnd,IDC_64)
		mov g_hBtnIs32,	rv(GetDlgItem,hWnd,IDC_32)
		mov g_hBtnIs16,	rv(GetDlgItem,hWnd,IDC_16)
		mov g_hChkSign,	rv(GetDlgItem,hWnd,IDC_SIGNED)
		
		invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,OFFSET szNullString
		invoke SendMessage,g_hBtnIs64,BM_SETCHECK,BST_CHECKED,0
		invoke SendMessage,g_hEdit,EM_LIMITTEXT,20,0
		fn SendMessage,g_hEdit,WM_SETTEXT,0,"enter divisor"

		mov g_pfnEdit,rv(SetWindowLong,g_hEdit,GWL_WNDPROC,OFFSET EditHook)

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		movzx edx,WORD ptr wParam+2
		.if eax==IDC_CALC
			.if edx == BN_CLICKED
				.if g_bNoText == 1
					invoke SendMessage,g_hEdit,WM_SETTEXT,0,OFFSET szNullString
					mov g_bNoText,0
				.endif
				invoke Calculate
			.endif

		.elseif eax==IDC_COPY
			invoke SendMessage,g_hRichEdit,EM_SETSEL,0,-1
			invoke SendMessage,g_hRichEdit,WM_COPY,0,0
			invoke SendMessage,g_hRichEdit,EM_SETSEL,0,0
			
;			invoke SendMessage,g_hRichEdit,WM_GETTEXTLENGTH,0,0
;			test eax,eax
;			.if !ZERO?
;				inc eax
;				push eax
;				mov hGlbMem,rv(GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,eax)
;				invoke GlobalLock,eax
;				pop ecx
;				invoke SendMessage,g_hRichEdit,WM_GETTEXT,ecx,eax
;				invoke GlobalUnlock,hGlbMem
;
;				invoke OpenClipboard,hWnd
;				invoke SetClipboardData,CF_TEXT,hGlbMem
;				invoke CloseClipboard
;			.else
;				fn MessageBox,hWnd,"no text to copy!","error:",MB_OK
;			.endif
		.elseif eax == IDC_64
			.if edx == BN_CLICKED
				invoke SendMessage,g_hChkSign,BM_GETCHECK,0,0
				.if eax == BST_CHECKED
					invoke SendMessage,g_hEdit,EM_LIMITTEXT,21,0
				.else
					invoke SendMessage,g_hEdit,EM_LIMITTEXT,20,0
				.endif
			.endif
		.elseif eax == IDC_32
			.if edx == BN_CLICKED
				invoke SendMessage,g_hChkSign,BM_GETCHECK,0,0
				.if eax == BST_CHECKED
					invoke SendMessage,g_hEdit,EM_LIMITTEXT,11,0
				.else
					invoke SendMessage,g_hEdit,EM_LIMITTEXT,10,0
				.endif
			.endif
		.elseif eax == IDC_16
			.if edx == BN_CLICKED
				invoke SendMessage,g_hChkSign,BM_GETCHECK,0,0
				.if eax == BST_CHECKED
					invoke SendMessage,g_hEdit,EM_LIMITTEXT,6,0
				.else
					invoke SendMessage,g_hEdit,EM_LIMITTEXT,5,0
				.endif
			.endif
		.elseif eax == IDC_EDIT
			.if edx == EN_SETFOCUS
				.if g_bNoText == 1
					invoke SendMessage,g_hEdit,WM_SETTEXT,0,OFFSET szNullString
					mov g_bNoText,0
				.endif
			.endif
		.endif

	.elseif uMsg == WM_CTLCOLORSTATIC
		invoke CreateSolidBrush,-1
		invoke SelectObject,wParam,eax
		ret
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWnd
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

align 16
Calculate proc
LOCAL szEditBuffer[32]:BYTE
LOCAL szOutTxt[512]:BYTE
LOCAL nChar:DWORD

	invoke SendMessage,g_hEdit,WM_GETTEXT,21,ADDR szEditBuffer
	mov nChar,eax
	test eax,eax
	.if !ZERO?

		invoke CheckState
		.if eax == 64
			.if nChar > 20
				fn MessageBox,0,"a 64 bit number has a maximum of 20 digits","error",MB_OK
				ret
			.endif
			mov eax,a2uq(ADDR szEditBuffer)
			mov ecx,DWORD ptr [eax]
			mov edx,DWORD ptr [eax+4]
			.if !(ecx == 0 && edx == 0)
				.if !(edx == 0 && ecx == 1)
					invoke make_const_64,edx::ecx
					mov szOutTxt[0],0

					.if d64.a == 0
						strcat		 ADDR szOutTxt," mov rax,X",nl
						strcat		 ADDR szOutTxt," mov rdx,0",xqword$(d64.m),"h",nl
						strcat		 ADDR szOutTxt," mul rdx",nl
						.if d64.s !=0
							strcat	 ADDR szOutTxt," shr rdx,0",xdword$(d64.s),"h",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," rdx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d64.a == 1
						strcat			 ADDR szOutTxt," mov rax,X",nl
						strcat			 ADDR szOutTxt," mov rdx,0",xqword$(d64.m),"h",nl
						strcat			 ADDR szOutTxt," add rax,1",nl
						strcat           ADDR szOutTxt," .if !!CARRY?",nl
						strcat			 ADDR szOutTxt,"     mul rdx",nl
						strcat           ADDR szOutTxt," .endif",nl
						.if d64.s != 0
							strcat		 ADDR szOutTxt," shr rdx,0",xdword$(d64.s),"h",nl
						.endif
						mov edx,cat$(	 ADDR szOutTxt," ",sc," rdx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d64.a == 2
						strcat		 ADDR szOutTxt," cmp X,0",xqword$(d64.m),"h",nl
						strcat		 ADDR szOutTxt," mov rdx,0",nl
						strcat		 ADDR szOutTxt," sbb rdx,-1",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," rdx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d64.a == 3
						strcat		 ADDR szOutTxt," shr X,0",xdword$(d64.s),"h",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," X = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
					.endif
				.else
					mov edx,chr$(" divsion by 1 is unnecessary !")
					invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
				.endif
			.else
				mov edx,chr$(" divsion by 0 isn't allowed !")
				invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
			.endif
		.elseif eax == 32
			.if nChar > 10
				fn MessageBox,0,"a 32 bit number has a maximum of 10 digits","error",MB_OK
				ret
			.endif
			mov eax,a2ud(ADDR szEditBuffer)
			mov eax,DWORD ptr [eax]
			.if eax != 0
				.if eax != 1
					invoke make_const_32,eax
					mov szOutTxt[0],0

					.if d32.a == 0
						strcat		 ADDR szOutTxt," mov eax,X",nl
						strcat		 ADDR szOutTxt," mov edx,0",xdword$(d32.m),"h",nl
						strcat		 ADDR szOutTxt," mul edx",nl
						.if d32.s !=0
							strcat	 ADDR szOutTxt," shr edx,0",xdword$(d32.s),"h",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," edx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d32.a == 1
						strcat			 ADDR szOutTxt," mov eax,X",nl
						strcat			 ADDR szOutTxt," mov edx,0",xdword$(d32.m),"h",nl
						strcat			 ADDR szOutTxt," add eax,1",nl
						strcat           ADDR szOutTxt," .if !!CARRY?",nl
						strcat			 ADDR szOutTxt,"     mul edx",nl
						strcat           ADDR szOutTxt," .endif",nl
						.if d32.s != 0
							strcat		 ADDR szOutTxt," shr edx,0",xdword$(d32.s),"h",nl
						.endif
						mov edx,cat$(	 ADDR szOutTxt," ",sc," edx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d32.a == 2
						strcat		 ADDR szOutTxt," cmp X,0",xdword$(d32.m),"h",nl
						strcat		 ADDR szOutTxt," mov edx,0",nl
						strcat		 ADDR szOutTxt," sbb edx,-1",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," edx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d32.a == 3
						strcat		 ADDR szOutTxt," shr X,0",xdword$(d32.s),"h",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," X = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
					.endif
				.else
					mov edx,chr$(" divsion by 1 is unnecessary !")
					invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
				.endif
			.else
				mov edx,chr$(" divsion by 0 isn't allowed !")
				invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
			.endif
		.elseif eax == 16
			.if nChar > 5
				fn MessageBox,0,"a 16 bit number has a maximum of 5 digits","error",MB_OK
				ret
			.endif
			mov eax,a2uw(ADDR szEditBuffer)
			movzx eax,WORD ptr [eax]
			.if eax != 0
				.if eax != 1

					invoke make_const_16,ax
					mov szOutTxt[0],0

					.if d16.a == 0
						strcat		 ADDR szOutTxt," mov ax,X",nl
						strcat		 ADDR szOutTxt," mov dx,0",xword$(d16.m),"h",nl
						strcat		 ADDR szOutTxt," mul dx",nl
						.if d16.s !=0
							strcat	 ADDR szOutTxt," shr dx,0",xword$(d16.s),"h",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," dx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d16.a == 1
						strcat			 ADDR szOutTxt," mov ax,X",nl
						strcat			 ADDR szOutTxt," mov dx,0",xword$(d16.m),"h",nl
						strcat			 ADDR szOutTxt," add ax,1",nl
						strcat           ADDR szOutTxt," .if !!CARRY?",nl
						strcat			 ADDR szOutTxt,"     mul dx",nl
						strcat           ADDR szOutTxt," .endif",nl
						.if d16.s != 0
							strcat		 ADDR szOutTxt," shr dx,0",xword$(d16.s),"h",nl
						.endif
						mov edx,cat$(	 ADDR szOutTxt," ",sc," dx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d16.a == 2
						strcat		 ADDR szOutTxt," cmp X,0",xword$(d16.m),"h",nl
						strcat		 ADDR szOutTxt," mov dx,0",nl
						strcat		 ADDR szOutTxt," sbb dx,-1",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," dx = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif d16.a == 3
						strcat		 ADDR szOutTxt," shr X,0",xword$(d16.s),"h",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," X = quotient")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
					.endif
				.else
					mov edx,chr$(" divsion by 1 is unnecessary !")
					invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
				.endif
			.else
				mov edx,chr$(" divsion by 0 isn't allowed !")
				invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
			.endif

		.elseif eax == 64+1
			.if nChar > 21
				fn MessageBox,0,"a 64 bit number has a maximum of 20 digits (21 with sign)","error",MB_OK
				ret
			.endif
			mov eax,a2sq(ADDR szEditBuffer)
			mov edx,DWORD ptr [eax+4]
			mov eax,DWORD ptr [eax]
			.if eax != 0 || edx != 0
				.if !(eax == 1 && edx == 0)
					invoke make_const_signed_64,edx::eax
					mov szOutTxt[0],0

					.if sd64.a == 0
						strcat		 ADDR szOutTxt," mov rcx,X",nl
						strcat		 ADDR szOutTxt," mov rax,0",xqword$(sd64.m),"h",nl
						strcat		 ADDR szOutTxt," imul rcx",nl
						.if sd64.flg & MASK a0_1
							strcat	 ADDR szOutTxt," sar rdx,0",xdword$(sd64.s),"h",nl
						.endif
						strcat		 ADDR szOutTxt," shr rcx,63",nl
						strcat		 ADDR szOutTxt," add rdx,rcx",nl
						.if sd64.flg & MASK a0_2
							strcat	 ADDR szOutTxt," neg rdx",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in rdx")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd64.a == 1
						strcat		 ADDR szOutTxt," mov rcx,X",nl
						strcat		 ADDR szOutTxt," mov rax,0",xqword$(sd64.m),"h",nl
						strcat		 ADDR szOutTxt," imul rcx",nl
						strcat		 ADDR szOutTxt," add rdx,rcx",nl
						.if sd64.flg & MASK a1_1
							strcat	 ADDR szOutTxt," sar rdx,0",xdword$(sd64.s),"h",nl
						.endif
						strcat		 ADDR szOutTxt," shr rcx,63",nl
						strcat		 ADDR szOutTxt," add rdx,rcx",nl
						.if sd64.flg & MASK a1_2
							strcat	 ADDR szOutTxt," neg rdx",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in rdx")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd64.a == 2
						strcat		 ADDR szOutTxt," neg X",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in X")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd64.a == 3
						strcat		 ADDR szOutTxt," mov rax,X",nl
						strcat		 ADDR szOutTxt," cmp rax,08000000000000000h",nl
						strcat		 ADDR szOutTxt," sbb rax,-1",nl
						strcat		 ADDR szOutTxt," sar rax,1",nl
						.if sd64.flg & MASK a3
							strcat	 ADDR szOutTxt," neg rax",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in rax")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd64.a == 4
						strcat		 ADDR szOutTxt," mov rax,X",nl
						strcat		 ADDR szOutTxt," cqo",nl
						strcat		 ADDR szOutTxt," and rdx,0",xqword$(sd64.m),"h",nl
						strcat		 ADDR szOutTxt," add rax,rdx",nl
						.if sd64.flg & MASK a4_1
							strcat	 ADDR szOutTxt," sar rax,0",xdword$(sd64.s),"h",nl
						.endif
						.if sd64.flg & MASK a4_2
							strcat	 ADDR szOutTxt," neg rax",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in rax")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
					.endif
				.else
					mov edx,chr$(" divsion by 1 is unnecessary !")
					invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
				.endif
			.else
				mov edx,chr$(" divsion by 0 isn't allowed !")
				invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
			.endif
		.elseif eax == 32+1
			.if nChar > 11
				fn MessageBox,0,"a 32 bit number has a maximum of 10 digits (11 with sign)","error",MB_OK
				ret
			.endif
			mov eax,a2sd(ADDR szEditBuffer)
			mov eax,DWORD ptr [eax]
			.if eax != 0
				.if eax != 1
					invoke make_const_signed_32,eax
					mov szOutTxt[0],0

					.if sd32.a == 0
						strcat		 ADDR szOutTxt," mov ecx,X",nl
						strcat		 ADDR szOutTxt," mov eax,0",xdword$(sd32.m),"h",nl
						strcat		 ADDR szOutTxt," imul ecx",nl
						.if sd32.flg & MASK a0_1
							strcat	 ADDR szOutTxt," sar edx,0",xdword$(sd32.s),"h",nl
						.endif
						strcat		 ADDR szOutTxt," shr ecx,31",nl
						strcat		 ADDR szOutTxt," add edx,ecx",nl
						.if sd32.flg & MASK a0_2
							strcat	 ADDR szOutTxt," neg edx",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in edx")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd32.a == 1
						strcat		 ADDR szOutTxt," mov ecx,X",nl
						strcat		 ADDR szOutTxt," mov eax,0",xdword$(sd32.m),"h",nl
						strcat		 ADDR szOutTxt," imul ecx",nl
						strcat		 ADDR szOutTxt," add edx,ecx",nl
						.if sd32.flg & MASK a1_1
							strcat	 ADDR szOutTxt," sar edx,0",xdword$(sd32.s),"h",nl
						.endif
						strcat		 ADDR szOutTxt," shr ecx,31",nl
						strcat		 ADDR szOutTxt," add edx,ecx",nl
						.if sd32.flg & MASK a1_2
							strcat	 ADDR szOutTxt," neg edx",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in edx")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd32.a == 2
						strcat		 ADDR szOutTxt," neg X",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in X")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd32.a == 3
						strcat		 ADDR szOutTxt," mov eax,X",nl
						strcat		 ADDR szOutTxt," cmp eax,080000000h",nl
						strcat		 ADDR szOutTxt," sbb eax,-1",nl
						strcat		 ADDR szOutTxt," sar eax,1",nl
						.if sd32.flg & MASK a3
							strcat	 ADDR szOutTxt," neg eax",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in eax")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd32.a == 4
						strcat		 ADDR szOutTxt," mov eax,X",nl
						strcat		 ADDR szOutTxt," cdq",nl
						strcat		 ADDR szOutTxt," and edx,0",xdword$(sd32.m),"h",nl
						strcat		 ADDR szOutTxt," add eax,edx",nl
						.if sd32.flg & MASK a4_1
							strcat	 ADDR szOutTxt," sar eax,0",xdword$(sd32.s),"h",nl
						.endif
						.if sd32.flg & MASK a4_2
							strcat	 ADDR szOutTxt," neg eax",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in eax")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
					.endif
				.else
					mov edx,chr$(" divsion by 1 is unnecessary !")
					invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
				.endif
			.else
				mov edx,chr$(" divsion by 0 isn't allowed !")
				invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
			.endif
		.elseif eax == 16+1
			.if nChar > 6
				fn MessageBox,0,"a 16 bit number has a maximum of 5 digits (6 with sign)","error",MB_OK
				ret
			.endif
			mov eax,a2sw(ADDR szEditBuffer)
			movzx eax,WORD ptr [eax]
			.if eax != 0
				.if eax != 1
					invoke make_const_signed_16,ax
					mov szOutTxt[0],0

					.if sd16.a == 0
						strcat		 ADDR szOutTxt," mov cx,X",nl
						strcat		 ADDR szOutTxt," mov ax,0",xword$(sd16.m),"h",nl
						strcat		 ADDR szOutTxt," imul cx",nl
						.if sd16.flg & MASK a0_1
							strcat	 ADDR szOutTxt," sar dx,0",xdword$(sd16.s),"h",nl
						.endif
						strcat		 ADDR szOutTxt," shr cx,15",nl
						strcat		 ADDR szOutTxt," add dx,cx",nl
						.if sd16.flg & MASK a0_2
							strcat	 ADDR szOutTxt," neg dx",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in dx")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd16.a == 1
						strcat		 ADDR szOutTxt," mov cx,X",nl
						strcat		 ADDR szOutTxt," mov ax,0",xword$(sd16.m),"h",nl
						strcat		 ADDR szOutTxt," imul cx",nl
						strcat		 ADDR szOutTxt," add dx,cx",nl
						.if sd16.flg & MASK a1_1
							strcat	 ADDR szOutTxt," sar dx,0",xdword$(sd16.s),"h",nl
						.endif
						strcat		 ADDR szOutTxt," shr cx,15",nl
						strcat		 ADDR szOutTxt," add dx,cx",nl
						.if sd16.flg & MASK a1_2
							strcat	 ADDR szOutTxt," neg dx",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in dx")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd16.a == 2
						strcat		 ADDR szOutTxt," neg X",nl
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in X")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd16.a == 3
						strcat		 ADDR szOutTxt," mov ax,X",nl
						strcat		 ADDR szOutTxt," cmp ax,08000h",nl
						strcat		 ADDR szOutTxt," sbb ax,-1",nl
						strcat		 ADDR szOutTxt," sar ax,1",nl
						.if sd16.flg & MASK a3
							strcat	 ADDR szOutTxt," neg ax",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in ax")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx

					.elseif sd16.a == 4
						strcat		 ADDR szOutTxt," mov ax,X",nl
						strcat		 ADDR szOutTxt," cwd",nl
						strcat		 ADDR szOutTxt," and dx,0",xword$(sd16.m),"h",nl
						strcat		 ADDR szOutTxt," add ax,dx",nl
						.if sd16.flg & MASK a4_1
							strcat	 ADDR szOutTxt," sar ax,0",xdword$(sd16.s),"h",nl
						.endif
						.if sd16.flg & MASK a4_2
							strcat	 ADDR szOutTxt," neg ax",nl
						.endif
						mov edx,cat$(ADDR szOutTxt," ",sc," quotient now in ax")
						invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
					.endif
				.else
					mov edx,chr$(" divsion by 1 is unnecessary !")
					invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
				.endif
			.else
				mov edx,chr$(" divsion by 0 isn't allowed !")
				invoke SendMessage,g_hRichEdit,WM_SETTEXT,0,edx
			.endif
		.endif
	.else
		fn SendMessage,g_hEdit,WM_SETTEXT,0,"enter divisor"
		fn SendMessage,g_hRichEdit,WM_SETTEXT,0,OFFSET szNullString
		mov g_bNoText,1
	.endif

	ret

Calculate endp

align 16
CheckState proc
LOCAL bSigned:DWORD
	invoke SendMessage,g_hChkSign,BM_GETCHECK,0,0
	.if eax == BST_CHECKED
		mov bSigned,1
	.else
		mov bSigned,0
	.endif

	invoke SendMessage,g_hBtnIs64,BM_GETCHECK,0,0
	.if eax == BST_CHECKED
		mov eax,64
		add eax,bSigned
		ret
	.endif
	invoke SendMessage,g_hBtnIs32,BM_GETCHECK,0,0
	.if eax == BST_CHECKED
		mov eax,32
		add eax,bSigned
		ret
	.endif
	invoke SendMessage,g_hBtnIs16,BM_GETCHECK,0,0
	.if eax == BST_CHECKED
		mov eax,16
		add eax,bSigned
		ret
	.endif

	xor eax,eax
	ret

CheckState endp

align 16
EditHook proc hWnd:DWORD,uMsg:DWORD,wParam:DWORd,lParam:DWORD
	.if uMsg == WM_CHAR && !(rv(GetAsyncKeyState,VK_CONTROL) & 08000h)
		movzx eax,BYTE ptr wParam
		.if al == 0dh ;== "Enter" -> emulate button-click
			invoke SendMessage,g_hMainDlg,WM_COMMAND,IDC_CALC,BN_CLICKED SHL 16
			xor eax,eax
			ret
		.endif
		
		invoke SendMessage,g_hChkSign,BM_GETCHECK,0,0
		.if eax == BST_CHECKED
			movzx eax,BYTE ptr wParam
			;allowed: "0"-"9","-","Back","Delete"
			.if al >= '0' && al <= '9'	||\
			    al == '-' 				||\
			    al == 08h				||\
			    al == 010h
				invoke CallWindowProc,g_pfnEdit,hWnd,uMsg,wParam,lParam
				ret
			.endif
		.else
			movzx eax,BYTE ptr wParam
			;allowed: "0"-"9","Back","Delete"
			.if al >= '0' && al <= '9'	||\
			    al == 08h				||\
			    al == 010h
				invoke CallWindowProc,g_pfnEdit,hWnd,uMsg,wParam,lParam
				ret
			.endif
		.endif

		xor eax,eax
		ret
	.else
		invoke CallWindowProc,g_pfnEdit,hWnd,uMsg,wParam,lParam
		ret
	.endif

EditHook endp

include math.inc
include calc_const.inc

end start
