WinMain				PROTO :DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD
CheckState			PROTO 
Calculate			PROTO
EditHook 			PROTO :DWORD,:DWORD,:DWORD,:DWORD

make_const_64 proto :QWORD
make_const_32 proto :DWORD
make_const_16 proto :WORD

make_const_signed_64 proto :QWORD
make_const_signed_32 proto :SDWORD
make_const_signed_16 proto :SWORD

u64_mul 		proto :QWORD,:QWORD,:DWORD
u64_div 		proto :QWORD,:QWORD,:DWORD,:DWORD
u128_div 		proto :DWORD,:DWORD,:DWORD,:DWORD
u128_add 		proto :DWORD,:DWORD,:DWORD
u128_sub 		proto :DWORD,:DWORD,:DWORD
u64_log2 		proto :DWORD,:DWORD
u128_log2 		proto :DWORD,:DWORD
u64_make_odd 	proto :DWORD,:QWORD
u128_shr 		proto :DWORD,:DWORD,:DWORD
u128_shl 		proto :DWORD,:DWORD,:DWORD
u32_log2 		proto :DWORD

IDD_DIALOG		equ 1000
IDC_EDIT		equ 1001
IDC_CALC		equ 1002
IDC_COPY		equ 1003
IDC_64			equ 1004
IDC_32			equ 1005
IDC_16			equ 1006
IDC_RICH		equ 1007
IDC_SIGNED		equ 1008

div_64 struct 16 
	m	QWORD	?
	s	DWORD	?
	a	DWORD	?	
div_64 ends

div_32 struct 16
	m	DWORD	?
	s	DWORD	?
	a	DWORD	?
div_32 ends

div_16 struct 16
	m	WORD	?
	s	WORD	?
	a	WORD	?
div_16 ends

ALGO_FLG record a0_1:1,a0_2:1,a1_1:1,a1_2:1,a3:1 ,a4_1:1,a4_2:1 

div_s64 struct 16
	m	 QWORD		?
	s	 DWORD		?
	a	 DWORD		?
	flg  ALGO_FLG	<>	
div_s64 ends

div_s32 struct 16
	m	 DWORD		?
	s	 DWORD		?
	a	 DWORD		?
	flg  ALGO_FLG	<>	
div_s32 ends

div_s16 struct 16
	m	 WORD		?
	s	 DWORD		?
	a	 DWORD		?
	flg  ALGO_FLG	<>	
div_s16 ends


emov macro dest:req,src:req,DestFlag:req,SrcFlag:req

 IF (DestFlag EQ 128) AND(SrcFlag EQ 128)
 	
	push DWORD ptr [src]
	push DWORD ptr [src+4]
	push DWORD ptr [src+8]
	push DWORD ptr [src+12]
	pop DWORD ptr [dest+12]
	pop DWORD ptr [dest+8]
	pop DWORD ptr [dest+4]
	pop DWORD ptr [dest]
 	EXITM
 ELSEIF (DestFlag EQ 128+0) AND (SrcFlag EQ 64)
	push DWORD ptr [src]
	push DWORD ptr [src+4]
	pop DWORD ptr [dest+4]
	pop DWORD ptr [dest]
	mov DWORD ptr [dest+8],0
	mov DWORD ptr [dest+12],0
 	EXITM
 ELSEIF (DestFlag EQ 128+64) AND (SrcFlag EQ 64)
	push DWORD ptr [src]
	push DWORD ptr[src+4]
	pop DWORD ptr [dest+12]
	pop DWORD ptr [dest+4]
 	EXITM
 ELSEIF (DestFlag EQ 128+0) AND (SrcFlag EQ 128+64)
	push DWORD ptr [src+8]
	push DWORD ptr [src+12]
	pop DWORD ptr [dest+4]
	pop DWORD ptr [dest]
	mov DWORD ptr [dest+8],0
	mov DWORD ptr [dest+12],0
 	EXITM
 ELSEIF (DestFlag EQ 128+64) AND (SrcFlag EQ 128+64)
	push DWORD ptr [src+8]
	push DWORD ptr[src+12]
	pop DWORD ptr [dest+12]
	pop DWORD ptr [dest+4]
 	EXITM
 ELSEIF (DestFlag EQ 64) AND (SrcFlag EQ 64)
 	push DWORD ptr [src]
 	push DWORD ptr [src+4]
 	pop DWORD ptr [dest+4]
 	pop DWORD ptr [dest]
 	EXITM
 ELSEIF (DestFlag EQ 64) AND ( SrcFlag EQ 128+64)
 	push DWORD ptr [src+8]
 	push DWORD ptr [src+12]
 	pop DWORD ptr [dest+4]
 	pop DWORD ptr [dest]
 	EXITM 
 ENDIF
	
	%echo emov_ err: flags not defined
	
	
endm

lAddr macro LocalName:req,reg
	
	IFNB <reg>
		lea reg,LocalName
		EXITM <reg>
	ELSE
		lea eax,LocalName
		EXITM <eax>
	ENDIF
	
endm

IF_GE_128 macro lp_m128_1:req,lp_m128_2:req

	IFNDEF ig128_lbl_cntr_true
		ig128_lbl_cntr_true  = 0
		ig128_lbl_cntr_false = 0
	ELSE
		ig128_lbl_cntr_true  = ig128_lbl_cntr_true  + 1
		ig128_lbl_cntr_false = ig128_lbl_cntr_false + 1
	ENDIF
	
	mov esi,lp_m128_1
    mov eax,DWORD ptr [esi]
    mov ebx,DWORD ptr [esi+4]
    mov ecx,DWORD ptr [esi+8]
    mov edx,DWORD ptr [esi+12]
    
    mov esi,lp_m128_2
    cmp edx,DWORD ptr [esi+12]
    ja @CatStr(<ig128_true>,%ig128_lbl_cntr_true)                  
    jb @CatStr(<ig128_false>,%ig128_lbl_cntr_false)                     
    cmp ecx,DWORD ptr [esi+8] 
    ja @CatStr(<ig128_true>,%ig128_lbl_cntr_true)                  
    jb @CatStr(<ig128_false>,%ig128_lbl_cntr_false)                     
    cmp ebx,DWORD ptr [esi+4] 
    ja @CatStr(<ig128_true>,%ig128_lbl_cntr_true)                  
    jb @CatStr(<ig128_false>,%ig128_lbl_cntr_false)                      
    cmp eax,DWORD ptr [esi]   
    jb @CatStr(<ig128_false>,%ig128_lbl_cntr_false)                    
	@CatStr(<ig128_true>,%ig128_lbl_cntr_true,<:>)                   

endm  

ELSE_GE_128 macro	
	@CatStr(<ig128_false>,%ig128_lbl_cntr_false,<:>)
	@CatStr(<ig128_else_used>,%ig128_lbl_cntr_false) = 1	
endm

ENDIF_GE_128 macro
%	IFNDEF @CatStr(<ig128_else_used>,%ig128_lbl_cntr_false)
		@CatStr(<ig128_false>,%ig128_lbl_cntr_false,<:>)
	ENDIF
endm

IF_128 macro 
		@@:	invoke u128_shl,ADDR tmp[0],ADDR t,1
			invoke u128_add,ADDR tmp[0],ADDR tmp[0],OFFSET m128_const_1
			
			lea edi,r
			mov eax,DWORD ptr [edi]
			mov ebx,DWORD ptr [edi+4]
			mov ecx,DWORD ptr [edi+8]
			mov edx,DWORD ptr [edi+12]
			
			lea edi,tmp[0]
			cmp edx,DWORD ptr [edi+12]
			jb @if_128_true
			ja @if_128_false
			cmp ecx,DWORD ptr [edi+8]
			jb @if_128_true
			ja @if_128_false
			cmp ebx,DWORD ptr [edi+4]
			jb @if_128_true
			ja @if_128_false
			cmp eax,DWORD ptr [edi]
			jb @if_128_true
			jmp @if_128_false
			@if_128_true:	
endm


ELSE_128 macro 
			jmp @if_128_end	
	@if_128_false:
endm

ENDIF_128 macro
 @if_128_end:
endm
