
align 16
make_const_64 proc uses edi esi ebx uQword:QWORD
LOCAL tmp[3]:OWORD
LOCAL t:OWORD
LOCAL l:OWORD
LOCAL j:OWORD
LOCAL k:OWORD
LOCAL m:OWORD
LOCAL s:OWORD
LOCAL r:OWORD
LOCAL m_low:OWORD
LOCAL m_high:OWORD
LOCAL a:DWORD
LOCAL n:DWORD

    .data
        align 16
        m128_const_1    QWORD 1,0
        m64_const_m1    QWORD -1,0
    .code


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   set variables to 0                                            ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    lea eax,m_high
    xor edx,edx
    mov ecx,12
    assume eax: ptr DWORD
    .while ecx != 0
        mov [eax],edx
        mov [eax+4],edx
        mov [eax+8],edx
        mov [eax+12],edx
        add eax,16
        dec ecx
    .endw
    mov a,0
    mov n,0
    assume eax: NOTHING

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   if (d >= 0x8000000000000000UL)                                ;
    ;   {                                                             ;
    ;       a=2;                                                      ;
    ;       m=d;                                                      ;
    ;       s=0;                                                      ;
    ;       return(0);                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov eax,DWORD ptr uQword
    mov edx,DWORD ptr uQword+4
    .if edx >= 080000000h && eax >= 0
        mov DWORD ptr d64.m,eax
        mov DWORD ptr d64.m+4,edx
        mov d64.s,0
        mov d64.a,2
        ret
    .endif

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   t = odd                                                       ;
    ;   n =                                                           ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u64_make_odd,ADDR t,uQword
    mov n,eax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   if (t == 1)                                                   ;
    ;   {                                                             ;
    ;       if (n != 0)                                               ;
    ;       {                                                         ;
    ;           a=3;                                                  ;
    ;           s=n;                                                  ;
    ;       }                                                         ;
    ;       return(0);                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov eax,DWORD ptr t
    mov edx,DWORD ptr t+4
    .if edx == 0 && eax == 1
        .if n != 0
            mov d64.a,3
            m2m d64.s,n
            mov DWORD ptr d64.m,0
            mov DWORD ptr d64.m+4,0
        .endif
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   l = log2(t)+1;                                                ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u64_log2,ADDR l,ADDR t
    invoke u128_add,ADDR l,ADDR l,OFFSET m128_const_1


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   j = 0xFFFFFFFFFFFFFFFF % t;                                   ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u128_div,ADDR tmp[0],ADDR j,OFFSET m64_const_m1,ADDR t


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                     ;
    ;  k = (((U128) (1)) << (64 + l)) / ((U128) (0xffffffffffffffff - j)) ;
    ;                                                                     ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov edx,DWORD ptr l
    add edx,64
    invoke  u128_shl,ADDR tmp[0],OFFSET m128_const_1,edx
    invoke u128_sub,ADDR tmp[16],OFFSET m64_const_m1,ADDR j
    invoke u128_div,ADDR k,ADDR tmp[32],ADDR tmp[0],ADDR tmp[16]

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m_low = (((U128) (1)) << (64 + l)) / t;                       ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u128_div,ADDR m_low,ADDR tmp[32],ADDR tmp[0],ADDR t


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m_high = ((((U128) (1)) << (64 + l)) + k) / t;                ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u128_add,ADDR tmp[16],ADDR tmp[0],ADDR k
    invoke u128_div,ADDR m_high,ADDR tmp[32],ADDR tmp[16],ADDR t


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   while (((m_low >> 1) < (m_high >> 1)) && (l > 0))             ;
    ;   {                                                             ;
    ;       m_low = m_low >> 1;                                       ;
    ;       m_high = m_high >> 1;                                     ;
    ;       l = l - 1;                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    push DWORD ptr l
    d64_while_start:

        invoke u128_shr,ADDR tmp[0],ADDR m_low,1
        invoke u128_shr,ADDR tmp[16],ADDR m_high,1
        cmp DWORD ptr [esp],0
        je d64_while_end

        lea edi,tmp[0]
        mov eax,DWORD ptr [edi]
        mov ebx,DWORD ptr [edi+4]
        mov ecx,DWORD ptr [edi+8]
        mov edx,DWORD ptr [edi+12]

        lea edi,tmp[16]
        cmp edx,DWORD ptr [edi+12]
        jb d64_while_true
        ja d64_while_end
        cmp ecx,DWORD ptr [edi+8]
        jb d64_while_true
        ja d64_while_end
        cmp ebx,DWORD ptr [edi+4]
        jb d64_while_true
        ja d64_while_end
        cmp eax,DWORD ptr [edi]
        jb d64_while_true
        jmp d64_while_end
        d64_while_true:

            mov DWORD ptr m_low,eax
            mov DWORD ptr m_low+4,ebx
            mov DWORD ptr m_low+8,ecx
            mov DWORD ptr m_low+12,edx

            mov eax,DWORD ptr [edi]
            mov ebx,DWORD ptr [edi+4]
            mov ecx,DWORD ptr [edi+8]
            mov edx,DWORD ptr [edi+12]

            lea esi,m_high
            mov DWORD ptr m_high,eax
            mov DWORD ptr m_high+4,ebx
            mov DWORD ptr m_high+8,ecx
            mov DWORD ptr m_high+12,edx

            dec DWORD ptr [esp]

    jmp d64_while_start
    d64_while_end:
    pop DWORD ptr l



    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  if ((m_high >> 64) == 0)                                       ;
    ;  {                                                              ;
    ;      m = ((U64) (m_high));                                      ;
    ;      s = l;                                                     ;
    ;      a = 0;                                                     ;
    ;  }                                                              ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if DWORD ptr m_high+8 == 0 && DWORD ptr m_high+12 == 0

        mov eax,DWORD ptr m_high
        mov ebx,DWORD ptr m_high+4

        mov DWORD ptr m,eax
        mov DWORD ptr m+4,ebx
        mov DWORD ptr m+8,0
        mov DWORD ptr m+12,0


        mov eax,DWORD ptr l
        mov DWORD ptr s,eax
        mov DWORD ptr s+4,0
        mov DWORD ptr s+8,0
        mov DWORD ptr s+12,0

        mov a,0

    .else


        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;                                                             ;
        ;  s = log2(t);                                               ;
        ;                                                             ;
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        invoke u128_log2,ADDR s,ADDR t


        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;                                                             ;
        ;  m_low = (((U128) (1)) << (64 + s)) / ((U128) (t));         ;
        ;  r = ((U64) ((((U128) (1)) << (64 + s)) % ((U128) (t))));   ;
        ;                                                             ;
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        mov edx,DWORD ptr s
        add edx,64
        invoke u128_shl,ADDR tmp[0],OFFSET m128_const_1,edx
        invoke u128_div,ADDR m_low,ADDR r,ADDR tmp[0],ADDR t
        mov DWORD ptr r+8,0
        mov DWORD ptr r+12,0


        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;                                                                   ;
        ;  m = (r < ((t >> 1) + 1)) ? ((U64) (m_low)) : ((U64) (m_low)) + 1 ;
        ;  a = 1;                                                           ;
        ;                                                                   ;
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        IF_128 ;(r < ((t >> 1) + 1)) -> see MagicNumber64.inc
            mov eax,DWORD ptr m_low
            mov ebx,DWORD ptr m_low+4

            mov DWORD ptr m,eax
            mov DWORD ptr m+4,ebx
            mov DWORD ptr m+8,0
            mov DWORD ptr m+12,0
        ELSE_128
            mov DWORD ptr m_low+8,0
            mov DWORD ptr m_low+12,0
            invoke u128_add,ADDR m,ADDR m_low,OFFSET m128_const_1
        ENDIF_128
        mov a,1
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  while (!(m & 1))                                               ;
    ;  {                                                              ;
    ;     m = m >> 1;                                                 ;
    ;     s--;                                                        ;
    ;  }                                                              ;
    ;  s += n;                                                        ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .while !(DWORD ptr m & 1)
        invoke u128_shr,ADDR m,ADDR m,1
        invoke u128_sub,ADDR s,ADDR s,OFFSET m128_const_1
    .endw
    mov eax,n
    add DWORD ptr s,eax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  results: a = algorithm                                         ;
    ;           s = shift value                                       ;
    ;           m = multiplier                                        ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov edx,DWORD ptr m
    mov ecx,DWORD ptr m+4
    mov DWORD ptr d64.m,edx
    mov DWORD ptr d64.m+4,ecx
    mov eax,DWORD ptr s
    mov d64.s,eax
    m2m d64.a,a

    ret

make_const_64 endp

align 16
;#######################################################################;
;                                                                       ;
; Procedure to compute "magic numbers" to replace divisions of dwords   ;
; by multiplications for known constants.                               ;
; Originally adapted to assembly from C code by qWord, 2008             ;
; Modified to simplify the code by Raymond Filiatreault, 2009           ;
;                                                                       ;
;#######################################################################;
make_const_32 proc uses ebx uDword:DWORD
LOCAL L:DWORD
LOCAL n:DWORD
LOCAL t:DWORD
LOCAL powerL:DWORD
LOCAL powerH:DWORD
;U32 d, l, s, m, a, r, n, t;
;U64 m_low, m_high, j, k;

;-----------------------------------------------------------------------;
;                                                                       ;
; The cases for uDword=0 and uDword=1 are covered before entering this  ;
; procedure and are not repeated here.                                  ;
;                                                                       ;
;-----------------------------------------------------------------------;

Code:
      mov ebx,uDword
      .if ebx >= 080000000h
            mov   d32.m,ebx
            mov   d32.s,0
            mov   d32.a,2
            ret
      .endif
      
      bsr ecx,ebx           ; get log2(uDword) in ECX
      mov edx,ecx   		; save log2(uDword)
      bsf ecx,ebx   		; ecx = n
      mov eax,edx
      sub eax,ecx   		; log2(uDword)-n = log2(t)

      .if   ZERO?      		;would have been a power of 2
            mov   d32.m,0
            mov   d32.s,edx
            mov   d32.a,3
            ret
      .endif

      mov n,ecx     
      shr ebx,cl    		; reduce uDword ==> t
      mov ecx,eax   		; ecx = log2(t)
      
      mov   t,ebx
      mov   edx,1
      shl   edx,cl            ; EDX = power of 2 lower than t
      mov   powerL,edx
      inc   ecx               ; log2(t)+1
      mov   L,ecx
      add   edx,edx           ; EDX = power of 2 higher than t
      mov   powerH,edx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                 ;
;   j = 0xFFFFFFFF % t;                                           ;
;                                                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      xor   edx,edx
      mov   eax,-1
      div   ebx               ; EBX = t
                              ; -> EDX = j = 0xFFFFFFFF % t

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                 ;
;  k = (((U64) (1)) << (32 + L)) / ((U64) (0xffffffff - j))       ;
;                                                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-----------------------------------------------------------------------;
;                                                                       ;
; The (1) << (32 + L) expression is equivalent to                       ;
; moving the "next power of 2 higher than t" into the high dword.       ;
; The (0xffffffff - j) dword can never be smaller than the above        ;
; such that division overflow would be impossible.                      ;
; k would always be a dword.                                            ;
;                                                                       ;
;-----------------------------------------------------------------------;

      mov   ebx,-1
      sub   ebx,edx           ; EDX = j -> EBX = (0xffffffff - j)
      mov   edx,powerH
      xor   eax,eax           ; EDX::EAX = (1) << (32 + L)
      div   ebx               ; -> EAX = k

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                 ;
;   m_high = ((((U64) (1)) << (32 + L)) + k) / t;                 ;
;                                                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-----------------------------------------------------------------------;
;                                                                       ;
; Loading the high dword with (1) << (32 + L) and trying to divide by t ;
; which is smaller, would result in a division overflow in 32-bit mode. ;
; The usual process is to divide the value of the high dword, retain    ;
; the remainder in EDX and load EAX with the original low dword for the ;
; final division to get the low dword.                                  ;
; The final quotient would be a qword where the first quotient becomes  ;
; the high dword.                                                       ;
;                                                                       ;
; Here, the high dword in known to be less than twice the divisor and   ;
; the remainder can be obtained simply by subtraction. And the final    ;
; qword quotient would have a 1 as the high dword.                      ;
;                                                                       ;
;-----------------------------------------------------------------------;

      mov   edx,powerH        ; EAX = k
      sub   edx,t
      div   t                 
      mov   edx,1             ; -> EDX::EAX = m_high

;-----------------------------------------------------------------------;
;                                                                       ;
; Since m_high and m_low will have to be shifted right at least once,   ;
; let's do it immediately on m_high. No use shifting EDX afterwards     ;
; since it is known that it would become 0 with the first shift.        ;
;                                                                       ;
;-----------------------------------------------------------------------;

      shrd  eax,edx,1
      mov   ebx,eax           ; EBX = m_high/2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                 ;
;   m_low = (((U64) (1)) << (32 + L)) / t;                        ;
;                                                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      xor   eax,eax
      mov   edx,powerH
      sub   edx,t
      div   t
      mov   edx,1             ; -> EDX::EAX = m_low
      shrd  eax,edx,1         ; EAX = m_low/2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                 ;
;   while (((m_low >> 1) < (m_high >> 1)) && (L > 0))             ;
;   {                                                             ;
;       m_low = m_low >> 1;                                       ;
;       m_high = m_high >> 1;                                     ;
;       L = L - 1;                                                ;
;   }                                                             ;
;                                                                 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-----------------------------------------------------------------------;
;                                                                       ;
; After shifting m_low and m_high once, both their high dwords have     ;
; always become 0. Comparing only the low dwords is thus sufficient.    ;
;                                                                       ;
;-----------------------------------------------------------------------;

      .if   eax != ebx
            mov d32.a,0
            dec L
            mov edx,ebx       ; save m_high to edx
            xor eax,ebx		  ; make different bits "visible"
            bsr ecx,eax		  ; get the position of highest unequal bit ...
			shr edx,cl
			sub L,ecx
      .else
            mov d32.a,1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                             ;
;  s = log2(t);                                               ;
;                                                             ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-----------------------------------------------------------------------;
;                                                                       ;
; We have L=log2(t)+1 already in memory and not needed anymore          ;
; Simply decrement it and reuse it.                                     ;
;                                                                       ;
;-----------------------------------------------------------------------;

            dec   L

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                             ;
;  m_low = (((U64) (1)) << (32 + s)) / ((U64) (t));           ;
;  r = ((U32) ((((U64) (1)) << (32 + s)) % ((U64) (t))));     ;
;                                                             ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            mov   edx,powerL
            xor   eax,eax
            div   t
            mov   ebx,eax           ; EBX = m_low, EDX = r

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                   ;
;  m = (r < ((t >> 1) + 1)) ? ((U32) (m_low)) : ((U32) (m_low)) + 1 ;
;  a = 1;                                                           ;
;                                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            mov   eax,t
            shr   eax,1
            .if   edx > eax
                  inc   ebx
            .endif
            mov   edx,ebx           ; EDX = magic number, L = shift
      .endif

      mov   ecx,L
      add   ecx,n
      mov   d32.m,edx
      mov   d32.s,ecx
      ret

make_const_32 endp

align 16
make_const_16 proc uses ebx uWord:WORD
LOCAL r:WORD
LOCAL m:WORD
LOCAL s:WORD
LOCAL l:WORD
LOCAL a:WORD
LOCAL n:WORD
LOCAL t:WORD
LOCAL j:DWORD
LOCAL k:DWORD
LOCAL m_low:DWORD
LOCAL m_high:DWORD
;U16 d, l, s, m, a, r, n, t;
;U32 m_low, m_high, j, k;



    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   set variables to 0                                            ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    lea eax,m_high
    xor edx,edx
    mov ecx,15
    .while ecx != 0
        mov WORD ptr [eax],dx
        add eax,2
        dec ecx
    .endw


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   if (d >= 0x8000UL)                                            ;
    ;   {                                                             ;
    ;       a=2;                                                      ;
    ;       m=d;                                                      ;
    ;       s=0;                                                      ;
    ;       return(0);                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if uWord >= 08000h
        mov d16.m,0
        mov d16.s,0
        mov d16.a,2
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   t = uWord;                                                    ;
    ;   n = 0;                                                        ;
    ;   while (!(t & 1))                                              ;
    ;   {                                                             ;
    ;       t >>= 1;                                                  ;
    ;       n++;                                                      ;
    ;   }                                                             ;
    ;   n =                                                           ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ax,uWord
    mov t,ax
    mov n,0
    .while !(t & 1)
        shr t,1
        inc n
    .endw


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   if (t == 1)                                                   ;
    ;   {                                                             ;
    ;       if (n != 0)                                               ;
    ;       {                                                         ;
    ;           a=3;                                                  ;
    ;           s=n;                                                  ;
    ;       }                                                         ;
    ;       return(0);                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if t == 1
        .if n != 0
            mov d16.m,0
            mov ax,n
            mov d16.s,ax
            mov d16.a,3

        .endif
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   l = log2(t)+1;                                                ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    xor eax,eax
    bsr ax,t
    inc ax
    mov l,ax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   j = 0xFFFF % t;                                               ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    xor edx,edx
    mov eax,0FFFFh
    div t
    mov WORD ptr j,dx

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  k = (((U32) (1)) << (16 + l)) / ((U32) (0xffff - j))           ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ebx,0ffffh
    sub ebx,j
    mov eax,1
    movzx ecx,BYTE ptr l
    shl eax,cl
    push eax
    xor edx,edx
    div ebx
    mov k,eax

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m_low = (((U32) (1)) << (16 + l)) / t;                       ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    movzx ecx,t
    xor edx,edx
    mov eax,DWORD ptr [esp]
    div ecx
    mov m_low,eax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m_high = ((((U32) (1)) << (16 + l)) + k) / t;                 ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    pop eax
    movzx ecx,t
    add eax,k
    xor edx,edx
    div ecx
    mov m_high,eax

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   while (((m_low >> 1) < (m_high >> 1)) && (l > 0))             ;
    ;   {                                                             ;
    ;       m_low = m_low >> 1;                                       ;
    ;       m_high = m_high >> 1;                                     ;
    ;       l = l - 1;                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    mov edx,m_low
    shr eax,1
    shr edx,1
    .while (edx < eax) && (l > 0)
        mov m_low,edx
        mov m_high,eax
        shr edx,1
        shr eax,1
        dec l
    .endw


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  if ((m_high >> 16) == 0)                                       ;
    ;  {                                                              ;
    ;      m = ((U16) (m_high));                                      ;
    ;      s = l;                                                     ;
    ;      a = 0;                                                     ;
    ;  }                                                              ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    .if WORD ptr m_high == 0

        m2m m,WORD ptr m_high
        m2m s,l
        mov a,0

    .else


        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;                                                             ;
        ;  s = log2(t);                                               ;
        ;                                                             ;
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        xor eax,eax
        bsr ax,t
        mov s,ax


        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;                                                             ;
        ;  m_low = (((U32) (1)) << (16 + s)) / ((U32) (t));           ;
        ;  r = ((U16) ((((U32) (1)) << (16 + s)) % ((U32) (t))));     ;
        ;                                                             ;
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movzx ecx,ax
        add ecx,16
        mov eax,1
        shl eax,cl
        movzx ecx,t
        div ecx
        mov m_low,eax
        mov r,dx


        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ;                                                                   ;
        ;  m = (r < ((t >> 1) + 1)) ? ((U16) (m_low)) : ((U16) (m_low)) + 1 ;
        ;  a = 1;                                                           ;
        ;                                                                   ;
        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movzx eax,t
        shr eax,1
        inc eax
        .if r < ax
            movzx eax,WORD ptr m_low
            mov m,ax
        .else
            movzx eax,WORD ptr m_low
            inc eax
            mov m,ax
        .endif
        mov a,1

    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  while (!(m & 1))                                               ;
    ;  {                                                              ;
    ;     m = m >> 1;                                                 ;
    ;     s--;                                                        ;
    ;  }                                                              ;
    ;  s += n;                                                        ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .while !(m & 1)
        shr m,1
        dec s
    .endw
    movzx eax,n
    add s,ax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;  results: a = algorithm                                         ;
    ;           s = shift value                                       ;
    ;           m = multiplier                                        ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ax,m
    mov d16.m,ax
    mov ax,s
    mov d16.s,ax
    mov ax,a
    mov d16.a,ax

    ret

make_const_16 endp

align 16
make_const_signed_64 proc uses ebx SignedQword:QWORD
LOCAL tmp[3]:OWORD
LOCAL qtmp:QWORD
LOCAL e:QWORD
LOCAL d:OWORD
LOCAL l:OWORD
LOCAL s:OWORD
LOCAL m:OWORD
LOCAL a:OWORD
LOCAL r:OWORD
LOCAL t:OWORD
LOCAL m_low:OWORD
LOCAL m_high:OWORD
LOCAL j:OWORD
LOCAL k:OWORD
;SQWORD e;
;U64 d, l, s, m, a, r, t;
;U128 m_low, m_high, j, k;

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   set local's to zero                                              ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ecx,15
    lea edx,k
    xor eax,eax
    assume edx: ptr DWORD
    .while ecx != 0
        mov [edx],eax
        mov [edx+4],eax
        mov [edx+8],eax
        mov [edx+12],eax
        add edx,16
        dec ecx
    .endw
    assume edx:NOTHING

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;  e = d;// == SignedDword                                           ;
    ;  d = labs(d);                                                      ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    emov e,SignedQword,64,64
    mov eax,DWORD ptr [SignedQword]
    mov edx,DWORD ptr [SignedQword+4]
    test edx,edx
    .if SIGN?
        not eax
        not edx
        add eax,1
        adc edx,0
    .endif
    mov DWORD ptr d,eax
    mov DWORD ptr d+4,edx


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   if (e == (-1))                                                   ;
    ;   {                                                                ;
    ;       a=2;                                                         ;
    ;       return(0);                                                   ;
    ;   }                                                                ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if DWORD ptr e == -1 && DWORD ptr e+1 == -1
        mov sd64.a,2
        ret
    .endif

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;     if (d == 2)                                                    ;
    ;     {                                                              ;
    ;           a3.flg = (e < 0) ? 1 : 0;                                ;
    ;           a = 3;                                                   ;
    ;           return(0);                                               ;
    ;     }                                                              ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if DWORD ptr d == 2 && DWORD ptr d+4 == 0
        mov sd64.a,3
        .if DWORD ptr e+4 & 080000000h
            mov sd64.flg,MASK a3
        .endif
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   if (!(d & (d - 1)))                                              ;
    ;   {                                                                ;
    ;       m=(d-1);                                                     ;
    ;       if (log2(d))                                                 ;
    ;       {                                                            ;
    ;           a4.flg1=1;                                               ;
    ;           s=log2(d);                                               ;
    ;       }                                                            ;
    ;       if (e < 0)                                                   ;
    ;           a4.flg2=1;                                               ;
    ;       return(0);                                                   ;
    ;   }                                                                ;
    ;   l = log2(d);                                                     ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u64_log2,ADDR l,ADDR d
    mov eax,DWORD ptr d
    mov edx,DWORD ptr d+4
    sub eax,1
    sbb edx,0
    mov sd64.flg,0
    .if (DWORD ptr d & eax) && (DWORD ptr d+4 & edx)
        mov DWORD ptr sd64.m,eax
        mov DWORD ptr sd64.m+4,edx

        .if DWORD ptr l != 0
            or sd64.flg,MASK a4_1
            m2m sd64.s,DWORD ptr l
        .endif
        .if DWORD ptr e+4 & 080000000h
            or sd64.flg,MASK a4_2
        .endif
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   j = (((U128) (0x8000000000000000h)) % ((U128) (d)));             ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov DWORD ptr tmp[4],080000000h
    emov tmp[16],d,128,64
    invoke u128_div,ADDR tmp[32],ADDR j,ADDR tmp[0],ADDR tmp[16]


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   k =(((U128)(1)) << (64 + l)) / ((U128) (0x8000000000000000h - j));
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ecx,DWORD ptr l
    mov eax,1
    xor edx,edx
    shld edx,eax,cl
    shl eax,cl
    mov DWORD ptr tmp[16],0
    mov DWORD ptr tmp[16]+4,0
    mov DWORD ptr tmp[16]+8,eax
    mov DWORD ptr tmp[16]+12,edx
    invoke u128_sub,ADDR tmp[32],ADDR tmp[0],ADDR j
    invoke u128_div,ADDR k,ADDR tmp[0],ADDR tmp[16],ADDR tmp[32]


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   m_low = (((U128) (1)) << (64 + l)) / d;                          ;
    ;   m_high = ((((U128) (1)) << (64 + l)) + k) / d;                   ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u128_div,ADDR m_low,ADDR tmp[32],ADDR tmp[16],ADDR d
    invoke u128_add,ADDR tmp[0],ADDR tmp[16],ADDR k
    invoke u128_div,ADDR m_high,ADDR tmp[32],ADDR tmp[0],ADDR d


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   while (((m_low >> 1) < (m_high >> 1)) && (l > 0))             ;
    ;   {                                                             ;
    ;       m_low = m_low >> 1;                                       ;
    ;       m_high = m_high >> 1;                                     ;
    ;       l = l - 1;                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    invoke u128_shr,ADDR tmp[0],ADDR m_low,1
    invoke u128_shr,ADDR tmp[16],ADDR m_high,1
    lea eax,tmp[0]
    lea edx,tmp[16]
    assume eax: ptr DWORD
    assume edx: ptr DWORD
    s64_while_start:
        cmp DWORD ptr l,0
        je s64_while_false

        mov ecx,[eax+12]
        cmp [edx+12],ecx
        ja s64_while_true
        jb s64_while_false
        mov ecx,[eax+8]
        cmp [edx+8],ecx
        ja s64_while_true
        jb s64_while_false
        mov ecx,[eax+4]
        cmp [edx+4],ecx
        ja s64_while_true
        jb s64_while_false
        mov ecx,[eax]
        cmp [edx],ecx
        jbe s64_while_false
    s64_while_true:

        emov m_low,tmp[0],128,128
        emov m_high,tmp[16],128,128
        invoke u128_shr,ADDR tmp[0], ADDR tmp[0],1
        invoke u128_shr,ADDR tmp[16],ADDR tmp[16],1
        dec DWORD ptr l

        jmp s64_while_start
    s64_while_false:

    assume eax: NOTHING
    assume eax: NOTHING


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m = ((U64) (m_high));                                         ;
    ;   s = l;                                                        ;
    ;   a = (m_high >> 63) ? 1 : 0;                                   ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    emov sd64.m,m_high,64,64
    m2m sd64.s,DWORD ptr l
    lea eax,m_high
    assume eax: ptr DWORD
    .if [eax+12] & 07fffffffh || [eax+8] & 0ffffffffh || [eax+4]& 080000000h
        mov sd64.a,1
    .else
        mov sd64.a,0
    .endif
    assume eax: NOTHING

   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;                                                                  ;
   ;    if (a)                                                        ;
   ;    {                                                             ;
   ;        if (s)                                                    ;
   ;            a1.flag1=1;                                           ;
   ;        if (e < 0)                                                ;
   ;            a1.flag2=1;                                           ;
   ;                                                                  ;
   ;    }                                                             ;
   ;    else                                                          ;
   ;    {                                                             ;
   ;        if (s)                                                    ;
   ;            a0.flag1=1;                                           ;
   ;        if (e < 0)                                                ;
   ;            a0.flag2=1;                                           ;
   ;    }                                                             ;
   ;                                                                  ;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   mov sd64.flg,0
   .if sd64.a
        .if sd64.s
            or sd64.flg,MASK a1_1
        .endif
        .if DWORD ptr e+4 & 080000000h
            or sd64.flg,MASK a1_2
        .endif
   .else
        .if sd64.s
            or sd64.flg,MASK a0_1
        .endif
        .if DWORD ptr e+4 & 080000000h
            or sd64.flg,MASK a0_2
        .endif
   .endif

    ret

make_const_signed_64 endp

align 16
make_const_signed_32 proc  uses ebx SignedDword:SDWORD
LOCAL e:SDWORD
LOCAL d:DWORD
LOCAL l:DWORD
LOCAL s:DWORD
LOCAL m:DWORD
LOCAL a:DWORD
LOCAL r:DWORD
LOCAL t:DWORD
LOCAL m_low:QWORD
LOCAL m_high:QWORD
LOCAL j:QWORD
LOCAL k:QWORD
LOCAL tmp:QWORD
;long e;
;U32 res1, res2;
;U32 d, l, s, m, a, r, t;
;U64 m_low, m_high, j, k;

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;  e = d;// == SignedDword                                           ;
    ;  d = labs(d);                                                      ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov eax,SignedDword
    mov e,eax
    test eax,eax
    .if SIGN?
        neg eax
    .endif
    mov d,eax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   if (e == (-1))                                                   ;
    ;   {                                                                ;
    ;       a=2;                                                         ;
    ;       return(0);                                                   ;
    ;   }                                                                ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if e == -1
        mov sd32.a,2
        ret
    .endif

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;     if (d == 2)                                                    ;
    ;     {                                                              ;
    ;           a3.flg = (e < 0) ? 1 : 0;                                ;
    ;           a = 3;                                                   ;
    ;           return(0);                                               ;
    ;     }                                                              ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if d == 2
        mov sd32.a,3
        .if e < 0
            mov sd32.flg,MASK a3
        .endif
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   if (!(d & (d - 1)))                                              ;
    ;   {                                                                ;
    ;       m=(d-1);                                                     ;
    ;       if (log2(d))                                                 ;
    ;       {                                                            ;
    ;           a4.flg1=1;                                               ;
    ;           s=log2(d);                                               ;
    ;       }                                                            ;
    ;       if (e < 0)                                                   ;
    ;           a4.flg2=1;                                               ;
    ;       return(0);                                                   ;
    ;   }                                                                ;
    ;   l = log2(d);                                                     ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    xor eax,eax
    bsr eax,d
    mov l,eax
    mov ecx,d
    lea edx,[ecx-1]
    and ecx,edx
    .if !(ecx)
        mov sd32.flg,0
        mov sd32.a,4
        mov sd32.m,edx
        .if eax
            mov sd32.flg,MASK a4_1
            mov sd32.s,eax
        .endif
        .if e < 0
            or sd32.flg,MASK a4_2
        .endif
        ret
    .endif



    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   j = (((U64) (0x80000000)) % ((U64) (d)));                        ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    xor edx,edx
    mov ecx,d
    mov eax,080000000h
    div ecx
    mov DWORD ptr j,edx
    mov DWORD ptr j+4,0

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   k = (((U64) (1)) << (32 + l)) / ((U64) (0x80000000 - j));        ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov eax,1
    mov ecx,l
    shl eax,cl
    mov ecx,080000000h
    xor edx,edx
    sub ecx,DWORD ptr j
    sbb edx,DWORD ptr j+4
    push lAddr(tmp,ebx)  ;invoke u64_div, eax:0 , edx:ecx , ADDR k , ADDR tmp
    push lAddr(k,ebx)    ;
    push edx             ;
    push ecx             ;
    push eax             ;
    push 0               ;
    call u64_div         ;

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   m_low = (((U64) (1)) << (32 + l)) / d;                           ;
    ;   m_high = ((((U64) (1)) << (32 + l)) + k) / d;                    ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    push lAddr(tmp,ebx)  ;invoke u64_div, eax:0 , 0:d  , ADDR m_low , ADDR tmp
    push lAddr(m_low,ebx);
    push 0               ;
    push d               ;
    push eax             ;
    push 0               ;
    call u64_div         ;

    xor ecx,ecx
    mov edx,eax
    add ecx,DWORD ptr k
    adc edx,DWORD ptr k+4

    push lAddr(tmp,ebx)     ;invoke u64_div, edx:ecx , 0:d , ADDR m_high , ADDR tmp
    push lAddr(m_high,ebx)  ;
    push 0                  ;
    push d                  ;
    push edx                ;
    push ecx                ;
    call u64_div            ;


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   while (((m_low >> 1) < (m_high >> 1)) && (l > 0))             ;
    ;   {                                                             ;
    ;       m_low = m_low >> 1;                                       ;
    ;       m_high = m_high >> 1;                                     ;
    ;       l = l - 1;                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov eax,DWORD ptr m_low
    mov edx,DWORD ptr m_low+4
    mov ebx,DWORD ptr m_high
    mov ecx,DWORD ptr m_high+4
    shrd eax,edx,1
    shr edx,1
    shrd ebx,ecx,1
    shr ecx,1
    .while ((ecx > edx ) || (ecx == edx && ebx > eax)) && (l > 0)
        mov DWORD ptr m_low,eax
        mov DWORD ptr m_low+4,edx
        mov DWORD ptr m_high,ebx
        mov DWORD ptr m_high+4,ecx
        shrd eax,edx,1
        shr edx,1
        shrd ebx,ecx,1
        shr ecx,1
        dec l
    .endw


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m = ((U32) (m_high));                                         ;
    ;   s = l;                                                        ;
    ;   a = (m_high >> 31) ? 1 : 0;                                   ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    m2m sd32.m,DWORD ptr m_high
    m2m sd32.s,l
    .if (DWORD ptr m_high+4 & 07fffffffh) || (DWORD ptr m_high & 080000000h)
        mov sd32.a,1
    .else
        mov sd32.a,0
    .endif


   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;                                                                  ;
   ;    if (a)                                                        ;
   ;    {                                                             ;
   ;        if (s)                                                    ;
   ;            a1.flag1=1;                                           ;
   ;        if (e < 0)                                                ;
   ;            a1.flag2=1;                                           ;
   ;                                                                  ;
   ;    }                                                             ;
   ;    else                                                          ;
   ;    {                                                             ;
   ;        if (s)                                                    ;
   ;            a0.flag1=1;                                           ;
   ;        if (e < 0)                                                ;
   ;            a0.flag2=1;                                           ;
   ;    }                                                             ;
   ;                                                                  ;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   mov sd32.flg,0
   .if sd32.a
        .if sd32.s
            or sd32.flg,MASK a1_1
        .endif
        .if e < 0
            or sd32.flg,MASK a1_2
        .endif
   .else
        .if sd32.s
            or sd32.flg,MASK a0_1
        .endif
        .if e < 0
            or sd32.flg,MASK a0_2
        .endif
   .endif

    ret

make_const_signed_32 endp

align 16
make_const_signed_16 proc uses ebx SignedWord:SWORD
LOCAL e:SWORD
LOCAL d:WORD
LOCAL l:WORD
LOCAL s:WORD
LOCAL m:WORD
LOCAL a:WORD
LOCAL r:WORD
LOCAL t:WORD
LOCAL m_low:DWORD
LOCAL m_high:DWORD
LOCAL j:DWORD
LOCAL k:DWORD
LOCAL tmp:DWORD
;SWORD e;
;U16 res1, res2;
;U16 d, l, s, m, a, r, t;
;U32 m_low, m_high, j, k;

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;  e = d;// == SignedWord                                           ;
    ;  d = labs(d);                                                      ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ax,SignedWord
    mov e,ax
    test ax,ax
    .if SIGN?
        neg ax
    .endif
    mov d,ax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   if (e == (-1))                                                   ;
    ;   {                                                                ;
    ;       a=2;                                                         ;
    ;       return(0);                                                   ;
    ;   }                                                                ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if e == -1
        mov sd16.a,2
        ret
    .endif

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;     if (d == 2)                                                    ;
    ;     {                                                              ;
    ;           a3.flg = (e < 0) ? 1 : 0;                                ;
    ;           a = 3;                                                   ;
    ;           return(0);                                               ;
    ;     }                                                              ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    .if d == 2
        mov sd16.a,3
        .if e < 0
            mov sd16.flg,MASK a3
        .endif
        ret
    .endif


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   if (!(d & (d - 1)))                                              ;
    ;   {                                                                ;
    ;       m=(d-1);                                                     ;
    ;       if (log2(d))                                                 ;
    ;       {                                                            ;
    ;           a4.flg1=1;                                               ;
    ;           s=log2(d);                                               ;
    ;       }                                                            ;
    ;       if (e < 0)                                                   ;
    ;           a4.flg2=1;                                               ;
    ;       return(0);                                                   ;
    ;   }                                                                ;
    ;   l = log2(d);                                                     ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    xor eax,eax
    bsr ax,d
    mov l,ax
    movzx ecx,d
    lea edx,[ecx-1]
    and ecx,edx
    .if !(ecx)
        mov sd16.flg,0
        mov sd16.a,4
        mov sd16.m,dx
        .if eax
            mov sd16.flg,MASK a4_1
            mov sd16.s,eax
        .endif
        .if e < 0
            or sd16.flg,MASK a4_2
        .endif
        ret
    .endif



    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   j = (((U32) (0x8000)) % ((U32) (d)));                            ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    xor edx,edx
    movzx ecx,d
    mov eax,08000h
    div ecx
    mov j,edx

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   k = (((U32) (1)) << (16 + l)) / ((U32) (0x8000 - j));            ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov eax,1
    movzx ecx,l
    lea ecx,[ecx+16]
    shl eax,cl
    mov ebx,eax

    mov ecx,08000h
    sub ecx,j
    xor edx,edx
    div ecx
    mov k,eax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                    ;
    ;   m_low = (((U32) (1)) << (16 + l)) / d;                           ;
    ;   m_high = ((((U32) (1)) << (16 + l)) + k) / d;                    ;
    ;                                                                    ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    movzx ecx,d
    xor edx,edx
    mov eax,ebx
    div ecx
    mov m_low,eax

    xor edx,edx
    mov eax,ebx
    add eax,k
    div ecx
    mov m_high,eax


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   while (((m_low >> 1) < (m_high >> 1)) && (l > 0))             ;
    ;   {                                                             ;
    ;       m_low = m_low >> 1;                                       ;
    ;       m_high = m_high >> 1;                                     ;
    ;       l = l - 1;                                                ;
    ;   }                                                             ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov edx,m_low
    shr eax,1
    shr edx,1
    .while (edx < eax) && (l > 0)
        mov m_low,edx
        mov m_high,eax
        shr eax,1
        shr edx,1
        dec l
    .endw


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;                                                                 ;
    ;   m = ((U16) (m_high));                                         ;
    ;   s = l;                                                        ;
    ;   a = (m_high >> 15) ? 1 : 0;                                   ;
    ;                                                                 ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    mov ax,WORD ptr m_high
    mov sd16.m,ax
    movzx eax,l
    mov sd16.s,eax
    .if (m_high & 07fff8000h)
        mov sd16.a,1
    .else
        mov sd16.a,0
    .endif


   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;                                                                  ;
   ;    if (a)                                                        ;
   ;    {                                                             ;
   ;        if (s)                                                    ;
   ;            a1.flag1=1;                                           ;
   ;        if (e < 0)                                                ;
   ;            a1.flag2=1;                                           ;
   ;                                                                  ;
   ;    }                                                             ;
   ;    else                                                          ;
   ;    {                                                             ;
   ;        if (s)                                                    ;
   ;            a0.flag1=1;                                           ;
   ;        if (e < 0)                                                ;
   ;            a0.flag2=1;                                           ;
   ;    }                                                             ;
   ;                                                                  ;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   mov sd16.flg,0
   .if sd16.a
        .if sd16.s
            or sd16.flg,MASK a1_1
        .endif
        .if e < 0
            or sd16.flg,MASK a1_2
        .endif
   .else
        .if sd16.s
            or sd16.flg,MASK a0_1
        .endif
        .if e < 0
            or sd16.flg,MASK a0_2
        .endif
   .endif

    ret

make_const_signed_16 endp
